diff -uNrd ircd-hybrid-7.0/modules/m_rehash.c anynet-3.0/modules/m_rehash.c
--- ircd-hybrid-7.0/modules/m_rehash.c	Wed Oct 16 22:28:51 2002
+++ anynet-3.0/modules/m_rehash.c	Thu Jan 22 12:16:04 2004
@@ -106,7 +106,8 @@
         }
       if(found)
         {
-          ilog(L_NOTICE, "REHASH %s From %s\n", parv[1], 
+          /* rain - removed extraneous \n */
+          ilog(L_NOTICE, "REHASH %s From %s", parv[1], 
 	       get_client_name(source_p, HIDE_IP));
           return;
         }
diff -uNrd ircd-hybrid-7.0/modules/m_starttls.c anynet-3.0/modules/m_starttls.c
--- ircd-hybrid-7.0/modules/m_starttls.c	Wed Dec 31 19:00:00 1969
+++ anynet-3.0/modules/m_starttls.c	Wed Feb  4 13:20:13 2004
@@ -0,0 +1,96 @@
+/*
+ * m_starttls.c: Client STARTTLS command support.
+ *
+ * Copyright (c) 2004  Ben Winslow.
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are
+ * met:
+ * 
+ * 1. Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright notice,
+ *    the above paragraph (the one permitting redistribution), this list of
+ *    conditions and the following disclaimer in the documentation and/or
+ *    other materials provided with the distribution.
+ * 
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
+ * IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ *
+ * $Id$
+ */
+
+#include "config.h"
+
+#ifdef SSL_CLIENT_SUPPORT
+#include "stdinc.h"
+#include "ssl_client.h"
+#include "msg.h"
+#include "handlers.h"
+#include "client.h"
+#include "s_conf.h"
+#include "isupport.h"
+#include "hook.h"
+#include "parse.h"
+#include "send.h"
+#include "modules.h"
+
+static void m_starttls(struct Client *, struct Client *, int, char **);
+
+struct Message starttls_msgtab = {
+	"STARTTLS", 0, 0, 0, 0, MFLG_SLOW | MFLG_UNREG, 0, 
+	{m_starttls, m_starttls, m_ignore, m_starttls}
+};
+
+#ifndef STATIC_MODULES
+void _modinit(void)
+{
+	mod_add_cmd(&starttls_msgtab);
+	
+	ServerInfo.ssl_status |= SSLC_STAT_STARTTLS;
+	hook_call_event("update_isupport", ISUP_PROPAGATE);
+}
+
+void _moddeinit(void)
+{
+	mod_del_cmd(&starttls_msgtab);
+	
+	ServerInfo.ssl_status &= ~SSLC_STAT_STARTTLS;
+	hook_call_event("update_isupport", ISUP_PROPAGATE);
+}
+
+const char *_version = "$Revision: 1.0 $";
+#endif
+
+/*
+ * m_starttls - STARTTLS command handler
+ */
+static void m_starttls(struct Client *client_p, struct Client *source_p,
+	int parc, char *parv[])
+{
+	/* this shouldn't ever happen */
+	if (!MyConnect(source_p))
+		return;
+
+	if (source_p->localClient->ssl_state != SSLC_STATE_NONE) {
+		sendto_one(source_p, "NOTICE %s :TLS/SSL already started: %s",
+			IsRegistered(source_p) ? source_p->name : "TLS",
+			SSLC_cipherinfo(source_p, 0));
+		return;
+	}
+
+	sendto_one(source_p, "NOTICE %s :Ready to start TLS",
+		IsRegistered(source_p) ? source_p->name : "TLS");
+	
+	source_p->localClient->ssl_state = SSLC_STATE_STARTTLS;
+}
+#endif
diff -uNrd ircd-hybrid-7.0/modules/m_stats.c anynet-3.0/modules/m_stats.c
--- ircd-hybrid-7.0/modules/m_stats.c	Tue May  6 01:32:16 2003
+++ anynet-3.0/modules/m_stats.c	Mon Feb  2 10:01:25 2004
@@ -108,7 +108,9 @@
 static void stats_deny(struct Client *);
 static void stats_exempt(struct Client *);
 static void stats_events(struct Client *);
+#if 0 /* rain - pending glines are no longer supported  */
 static void stats_pending_glines(struct Client *);
+#endif
 static void stats_glines(struct Client *);
 static void stats_hubleaf(struct Client *);
 static void stats_auth(struct Client *);
@@ -147,7 +149,8 @@
   { 'E',	stats_events,		1,	1,	},
   { 'f',	fd_dump,		1,	1,	},
   { 'F',	fd_dump,		1,	1,	},
-  { 'g',	stats_pending_glines,	1,	0,	},
+/* rain - pending glines are no longer supported */
+  { 'g',	stats_glines,		1,	0,	},
   { 'G',	stats_glines,		1,	0,	},
   { 'h',	stats_hubleaf,		1,	0,	},
   { 'H',	stats_hubleaf,		1,	0,	},
@@ -378,6 +381,7 @@
   show_events(source_p);
 }
 
+#if 0 /* rain - pending glines are no longer supported */
 /* stats_pending_glines()
  *
  * input	- client pointer
@@ -433,6 +437,7 @@
   sendto_one(source_p, ":%s NOTICE %s :End of Pending G-lines",
 	     me.name, source_p->name);
 }
+#endif
 
 /* stats_glines()
  *
@@ -448,6 +453,7 @@
   char *host;
   char *name;
   char *reason;
+  char buf[IRCD_BUFSIZE]; /* rain - gline time buffer */
 
   if(!ConfigFileEntry.glines)
   {
@@ -475,8 +481,18 @@
     else
       reason = "No Reason";
     
+    /* rain - throw gline time info into after and send that instead */
+    if (kill_ptr->hold == 0)
+    	ircsprintf(buf, "%s (%s) (sticky)", reason, smalldate(kill_ptr->ts));
+    else if (kill_ptr->hold - CurrentTime < 0)
+        ircsprintf(buf, "%s (%s) (expired %ld seconds ago, cleanup pending)",
+        	reason, smalldate(kill_ptr->ts), CurrentTime - kill_ptr->hold);
+    else
+	    ircsprintf(buf, "%s (%s) (%ld seconds remaining)", reason,
+	    	smalldate(kill_ptr->ts), kill_ptr->hold - CurrentTime);
+    
     sendto_one(source_p, form_str(RPL_STATSKLINE), me.name,
-	       source_p->name, 'G', host, name, reason);
+	       source_p->name, 'G', host, name, buf);
   }
 }
 
diff -uNrd ircd-hybrid-7.0/modules/m_tburst.c anynet-3.0/modules/m_tburst.c
--- ircd-hybrid-7.0/modules/m_tburst.c	Wed Dec 31 19:00:00 1969
+++ anynet-3.0/modules/m_tburst.c	Mon Feb  2 01:58:19 2004
@@ -0,0 +1,176 @@
+/*  contrib/m_tburst.c
+ *  Copyright (C) 2002 Hybrid Development Team
+ *
+ *  Redistribution and use in source and binary forms, with or without
+ *  modification, are permitted provided that the following conditions are
+ *  met:
+ *
+ *  1.Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ *  2.Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *  3.The name of the author may not be used to endorse or promote products
+ *    derived from this software without specific prior written permission.
+ *
+ *  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ *  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+ *  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ *  DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
+ *  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+ *  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+ *  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ *  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+ *  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
+ *  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ *  POSSIBILITY OF SUCH DAMAGE.
+ *
+ *  $Id: m_tburst.c,v 1.12 2002/12/18 05:33:29 db Exp $
+ */
+
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "common.h"
+#include "ircd.h"
+#include "send.h"
+#include "msg.h"
+#include "modules.h"
+#include "hook.h"
+#include "hash.h"
+#include "s_serv.h"
+#include "s_conf.h"
+
+
+/* TBURST_PROPAGATE
+ *
+ * If this is defined, when we receive a TBURST thats successful
+ * (ie: our topic changes), the TBURST will be propagated to other
+ * servers that support TBURST
+ */
+#define TBURST_PROPAGATE
+
+
+
+static void ms_tburst(struct Client *, struct Client *, int, char **);
+static void set_topic(struct Client *, struct Channel *, 
+		      time_t, char *, char *);
+static void set_tburst_capab();
+#ifndef STATIC_MODULES /* rain - unused if static module */
+static void unset_tburst_capab();
+#endif
+/* rain - made static */
+static int send_tburst(struct hook_burst_channel *);
+
+struct Message tburst_msgtab = {
+  "TBURST", 0, 0, 6, 0, MFLG_SLOW, 0,
+  {m_ignore, m_ignore, ms_tburst, m_ignore}
+};
+
+/*
+ * rain - changed initialization so that we can call this func from the
+ * static module init func
+ */
+#ifdef STATIC_MODULES
+void
+tburst_init(void)
+#else
+void
+_modinit(void)
+#endif
+{
+  mod_add_cmd(&tburst_msgtab);
+  hook_add_hook("burst_channel", (hookfn *)send_tburst);
+  set_tburst_capab();
+}
+
+#ifndef STATIC_MODULES
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&tburst_msgtab);
+  hook_del_hook("burst_channel", (hookfn *)send_tburst);
+  unset_tburst_capab();
+}
+
+const char *_version = "$Revision: 1.12 $";
+#endif
+
+/* ms_tburst()
+ * 
+ *      parv[0] = sender prefix
+ *      parv[1] = channel timestamp
+ *      parv[2] = channel
+ *      parv[3] = topic timestamp
+ *      parv[4] = topic setter
+ *      parv[5] = topic
+ */
+static void ms_tburst(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[])
+{
+  struct Channel *chptr;
+  time_t newchannelts;
+  time_t newtopicts;
+
+  newchannelts = atol(parv[1]);
+  newtopicts = atol(parv[3]);
+
+  if((chptr = hash_find_channel(parv[2])))
+  {
+    if(chptr->channelts < newchannelts)
+      return;
+
+    else if(chptr->channelts == newchannelts)
+    {
+      if(chptr->topic == NULL || (chptr->topic_time > newtopicts))
+	set_topic(source_p, chptr, newtopicts, parv[4], parv[5]);
+      else
+	return;
+    }
+
+    else
+      set_topic(source_p, chptr, newtopicts, parv[4], parv[5]);
+  }
+}
+
+static void set_topic(struct Client *source_p, struct Channel *chptr, 
+		      time_t newtopicts, char *topicwho, char *topic)
+{
+  set_channel_topic(chptr, topic, topicwho, newtopicts);
+
+  sendto_channel_local(ALL_MEMBERS, chptr, ":%s TOPIC %s :%s",
+		       ConfigServerHide.hide_servers ? me.name : me.name,
+		       chptr->chname, chptr->topic == NULL ? "" : chptr->topic);
+
+#ifdef TBURST_PROPAGATE
+  sendto_server(source_p, NULL, chptr, CAP_TBURST, NOCAPS, NOFLAGS,
+		":%s TBURST %ld %s %ld %s :%s",
+		me.name, chptr->channelts, chptr->chname,
+		chptr->topic_time, 
+                chptr->topic_info == NULL ? "" : chptr->topic_info,
+                chptr->topic == NULL ? "" : chptr->topic);
+#endif
+}
+
+static void set_tburst_capab()
+{
+  default_server_capabs |= CAP_TBURST;
+}
+
+#ifndef STATIC_MODULES /* rain - unused if module is static */
+static void unset_tburst_capab()
+{
+  default_server_capabs &= ~CAP_TBURST;
+}
+#endif
+
+static int send_tburst(struct hook_burst_channel *data)
+{
+  if(data->chptr->topic != NULL && IsCapable(data->client, CAP_TBURST))
+    sendto_one(data->client, ":%s TBURST %ld %s %ld %s :%s",
+               me.name, data->chptr->channelts, data->chptr->chname,
+	       data->chptr->topic_time, data->chptr->topic_info, 
+	       data->chptr->topic);
+
+  return 0;
+}
diff -uNrd ircd-hybrid-7.0/modules/m_topic.c anynet-3.0/modules/m_topic.c
--- ircd-hybrid-7.0/modules/m_topic.c	Mon Jun 10 21:39:38 2002
+++ anynet-3.0/modules/m_topic.c	Mon Feb  2 02:09:23 2004
@@ -145,7 +145,8 @@
                             ":%s TOPIC %s :%s",
                             parv[0], chptr->chname,
                             chptr->topic == NULL ? "" : chptr->topic);
-	      if(chptr->mode.mode & MODE_HIDEOPS)
+	      /* rain - allow admins to see ops in hideops chans */
+	      if((chptr->mode.mode & MODE_HIDEOPS) && !IsAdmin(source_p))
 		{
 		  sendto_channel_local(ONLY_CHANOPS_HALFOPS,
 				       chptr, ":%s!%s@%s TOPIC %s :%s",
@@ -192,8 +193,9 @@
                          me.name, parv[0],
                          root_chan->chname, chptr->topic);
 
+	        /* rain - allow admins to see topic setter in hideops chans */
                 if(!(chptr->mode.mode & MODE_HIDEOPS) ||
-                  is_any_op(chptr,source_p))
+                  is_any_op(chptr,source_p) || IsAdmin(source_p))
                 {
                   sendto_one(source_p, form_str(RPL_TOPICWHOTIME),
                              me.name, parv[0], root_chan->chname,
diff -uNrd ircd-hybrid-7.0/modules/m_trace.c anynet-3.0/modules/m_trace.c
--- ircd-hybrid-7.0/modules/m_trace.c	Wed Sep  4 21:10:24 2002
+++ anynet-3.0/modules/m_trace.c	Mon Feb  2 02:14:22 2004
@@ -42,16 +42,19 @@
 #include "modules.h"
 
 
+#if 0 /* rain - we don't cripple trace */
 static void m_trace(struct Client *, struct Client *, int, char **);
+#endif
 static void ms_trace(struct Client*, struct Client*, int, char**);
 static void mo_trace(struct Client*, struct Client*, int, char**);
 static struct Client* next_client_double(struct Client *next, const char* ch);
 
 static void trace_spy(struct Client *);
 
+/* rain - reuse mo_trace and mask hostnames there if necessary */
 struct Message trace_msgtab = {
   "TRACE", 0, 0, 0, 0, MFLG_SLOW, 0,
-  {m_unregistered, m_trace, ms_trace, mo_trace}
+  {m_unregistered, mo_trace, ms_trace, mo_trace}
 };
 
 #ifndef STATIC_MODULES
@@ -73,7 +76,7 @@
 static int report_this_status(struct Client *source_p, struct Client *target_p,int dow,
                               int link_u_p, int link_u_s);
 
-
+#if 0 /* using mo_trace */
 /*
  * m_trace()
  *
@@ -92,7 +95,7 @@
   sendto_one(source_p, form_str(RPL_ENDOFTRACE), me.name, parv[0], tname);
 }
 
-
+#endif
 /*
 ** mo_trace
 **      parv[0] = sender prefix
@@ -171,7 +174,8 @@
           sendto_one(source_p, form_str(RPL_TRACEOPERATOR),
                      me.name, parv[0], class_name, name, 
                      MyOper(source_p) ? ipaddr :
-		     (IsIPSpoof(target_p) ? "255.255.255.255" : ipaddr),
+                     /* rain - hide IP if non-oper */
+	             ((IsIPSpoof(target_p) || !IsOper(source_p)) ? "255.255.255.255" : ipaddr),
                      CurrentTime - target_p->lasttime,
                      (target_p->user) ? (CurrentTime - target_p->user->last) : 0);
         }
@@ -180,7 +184,8 @@
           sendto_one(source_p,form_str(RPL_TRACEUSER),
                      me.name, parv[0], class_name, name, 
                      MyOper(source_p) ? ipaddr : 
-		     (IsIPSpoof(target_p) ? "255.255.255.255" : ipaddr),
+                     /* rain - hide IP if non-oper */
+		     ((IsIPSpoof(target_p) || !IsOper(source_p)) ? "255.255.255.255" : ipaddr),
                      CurrentTime - target_p->lasttime,
                      (target_p->user)?(CurrentTime - target_p->user->last):0);
         }
@@ -299,7 +304,8 @@
   if (hunt_server(client_p, source_p, ":%s TRACE %s :%s", 2, parc, parv))
     return;
 
-  if( IsOper(source_p) )
+/* rain - always propogate traces */
+/*if( IsOper(source_p) ) */
     mo_trace(client_p,source_p,parc,parv);
   return;
 }
diff -uNrd ircd-hybrid-7.0/modules/m_unkline.c anynet-3.0/modules/m_unkline.c
--- ircd-hybrid-7.0/modules/m_unkline.c	Mon Nov 18 14:54:58 2002
+++ anynet-3.0/modules/m_unkline.c	Mon Feb  2 10:29:25 2004
@@ -46,15 +46,19 @@
 
 static void mo_unkline(struct Client*, struct Client*, int, char**);
 static void mo_undline(struct Client*, struct Client*, int, char**);
+#if 0 /* rain - no longer allowed with the new GLINE code */
 static void mo_ungline(struct Client*, struct Client*, int, char**);
+#endif
 
 struct Message msgtabs[] = {
   {"UNKLINE", 0, 0, 2, 0, MFLG_SLOW, 0,
    {m_unregistered, m_not_oper, m_error, mo_unkline}},
   {"UNDLINE", 0, 0, 2, 0, MFLG_SLOW, 0,
    {m_unregistered, m_not_oper, m_error, mo_undline}}, 
+#if 0
   {"UNGLINE", 0, 0, 2, 0, MFLG_SLOW, 0,
    {m_unregistered, m_not_oper, m_error, mo_ungline}}
+#endif
 };
 
 #ifndef STATIC_MODULES
@@ -63,7 +67,8 @@
 {
   mod_add_cmd(&msgtabs[0]);
   mod_add_cmd(&msgtabs[1]);
-  mod_add_cmd(&msgtabs[2]);
+/* rain - UNGLINE is no more */
+/*  mod_add_cmd(&msgtabs[2]); */
 }
 
 void
@@ -71,7 +76,8 @@
 {
   mod_del_cmd(&msgtabs[0]);
   mod_del_cmd(&msgtabs[1]);
-  mod_del_cmd(&msgtabs[2]);
+/* rain - UNGLINE is no more */
+/*  mod_del_cmd(&msgtabs[2]); */
 }
 const char *_version = "$Revision: 1.51 $";
 #endif
@@ -434,6 +440,7 @@
 **      parv[1] = gline to remove
 */
 
+#if 0 /* rain - no longer allowed with the new GLINE code */
 static void
 mo_ungline(struct Client *client_p, struct Client *source_p,
 	   int parc,char *parv[])
@@ -494,4 +501,4 @@
     }
 }
 
-
+#endif
diff -uNrd ircd-hybrid-7.0/modules/m_wallops.c anynet-3.0/modules/m_wallops.c
--- ircd-hybrid-7.0/modules/m_wallops.c	Thu Jan  9 01:20:07 2003
+++ anynet-3.0/modules/m_wallops.c	Mon Feb  2 02:16:37 2004
@@ -77,7 +77,8 @@
       return;
     }
 
-  sendto_wallops_flags(FLAGS_OPERWALL, source_p, "OPERWALL - %s", message);
+  /* rain - remove silly OPERWALL - header */
+  sendto_wallops_flags(FLAGS_OPERWALL, source_p, "%s", message);
   sendto_server(NULL, source_p, NULL, NOCAPS, NOCAPS, LL_ICLIENT,
                 ":%s WALLOPS :%s", parv[0], message);
 }
@@ -101,8 +102,9 @@
       return;
     }
 
+  /* rain - remove silly OPERWALL - header */
   if(IsClient(source_p))
-    sendto_wallops_flags(FLAGS_OPERWALL, source_p, "OPERWALL - %s", message);
+    sendto_wallops_flags(FLAGS_OPERWALL, source_p, "%s", message);
   else
     sendto_wallops_flags(FLAGS_WALLOP, source_p, "%s", message); 
 
diff -uNrd ircd-hybrid-7.0/modules/m_who.c anynet-3.0/modules/m_who.c
--- ircd-hybrid-7.0/modules/m_who.c	Thu Jan 16 18:54:02 2003
+++ anynet-3.0/modules/m_who.c	Mon Feb  2 03:45:29 2004
@@ -217,7 +217,8 @@
       if(IsServer(client_p))
 	client_burst_if_needed(client_p,target_p);
 
-      isinvis = IsInvisible(target_p);
+      /* rain - allow admins to see invisible users */
+      isinvis = IsInvisible(target_p) && !IsAdmin(source_p);
       for (lp = target_p->user->channel.head; lp; lp = lp->next)
 	{
 	  chptr = lp->data;
@@ -373,8 +374,11 @@
 
     if (IsInvisible(target_p))
     {
-      ClearMark(target_p);
-      continue;
+      /* rain - allow admins to see invisible users */
+      if (!IsAdmin(source_p)) {
+        ClearMark(target_p);
+        continue;
+      }
     }
 
     if (server_oper && !IsOper(target_p))
@@ -513,15 +517,17 @@
 
 	if(who_list[i].voiced)
 	{
+	  /* rain - allow admins to see ops in a hideops chan */
 	  if(target_p == source_p && is_voiced(chptr, source_p) && 
-	     chptr->mode.mode & MODE_HIDEOPS)
+	     ((chptr->mode.mode & MODE_HIDEOPS) && !IsAdmin(source_p)))
 	    do_who(source_p, target_p, chname, "+");
 	  else
 	    do_who(source_p, target_p, chname, voiced_flag);
 	}
 	else
 	{
-	  if(member || !IsInvisible(target_p))
+	  /* rain - allow admins to see invisible users */
+	  if(member || (!IsInvisible(target_p) || IsAdmin(source_p)))
 	    do_who(source_p, target_p, chname, who_list[i].flag);
 	}
 	who_list[i].ptr = who_list[i].ptr->next;
@@ -539,7 +545,8 @@
       {
 	target_p = ptr->data;
 
-	if(member || !IsInvisible(target_p))
+        /* allow admins to see invisible users */
+	if(member || (!IsInvisible(target_p) || IsAdmin(source_p)))
 	  do_who(source_p, target_p, chname, who_list[i].flag);
       }
     }
@@ -564,8 +571,10 @@
 {
   char  status[5];
 
-  ircsprintf(status,"%c%s%s", target_p->user->away ? 'G' : 'H',
-	     IsOper(target_p) ? "*" : "", op_flags );
+  /* rain - show invisible flag in WHO */
+  ircsprintf(status,"%c%s%s%s", target_p->user->away ? 'G' : 'H',
+	     IsOper(target_p) ? "*" : "",
+	     (IsInvisible(target_p) && IsOper(source_p)) ? "i" : "", op_flags );
 
   if(ConfigServerHide.hide_servers)
   {
diff -uNrd ircd-hybrid-7.0/modules/m_whois.c anynet-3.0/modules/m_whois.c
--- ircd-hybrid-7.0/modules/m_whois.c	Sat Feb  8 19:02:28 2003
+++ anynet-3.0/modules/m_whois.c	Mon Feb  2 02:24:08 2004
@@ -423,7 +423,8 @@
 	t = buf + mlen;
       }
 
-      if (chptr->mode.mode & MODE_HIDEOPS && !is_any_op(chptr,source_p))
+      /* rain - allow admins to see ops in a hideops chan */
+      if (((chptr->mode.mode & MODE_HIDEOPS) && !IsAdmin(source_p)) && !is_any_op(chptr,source_p))
       {
 	ircsprintf(t,"%s ",chname);
       }
@@ -451,6 +452,20 @@
 	       me.name, source_p->name, target_p->name,
                ServerInfo.network_name,
 	       ServerInfo.network_desc);
+
+#ifdef SSL_CLIENT_SUPPORT
+  if (IsSSL(target_p)) {
+    if (MyConnect(target_p) &&
+      target_p->localClient->ssl_state == SSLC_STATE_CONNECTED)
+
+      ircsprintf(buf, "using secure connection (%s)", SSLC_cipherinfo(target_p, 1));
+    else
+      strcpy(buf, "using secure connection");
+
+    sendto_one(source_p, form_str(RPL_WHOISSPECIAL), me.name,
+      source_p->name, target_p->name, buf);
+  }
+#endif
 
   if (target_p->user->away)
     sendto_one(source_p, form_str(RPL_AWAY), me.name,
diff -uNrd ircd-hybrid-7.0/servlink/control.c anynet-3.0/servlink/control.c
--- ircd-hybrid-7.0/servlink/control.c	Sat May 31 03:30:32 2003
+++ anynet-3.0/servlink/control.c	Mon Feb  2 06:52:43 2004
@@ -177,6 +177,22 @@
       in_state.crypt_state.rounds = 16;
       break;
 #endif
+/* rain - added AES support */
+#ifdef HAVE_EVP_AES_128_CFB
+    case CIPHER_AES_128:
+      in_state.crypt_state.cipher = EVP_aes_128_cfb();
+      break;
+#endif
+#ifdef HAVE_EVP_AES_192_CFB
+    case CIPHER_AES_192:
+      in_state.crypt_state.cipher = EVP_aes_192_cfb();
+      break;
+#endif
+#ifdef HAVE_EVP_AES_256_CFB
+    case CIPHER_AES_256:
+      in_state.crypt_state.cipher = EVP_aes_256_cfb();
+      break;
+#endif
     default:
       send_error("can't set decryption cipher - invalid cipher: %d!",
                  cipher); /* invalid cipher */
@@ -299,6 +315,22 @@
     case CIPHER_RC5_16:
       out_state.crypt_state.cipher = EVP_rc5_32_12_16_cfb();
       out_state.crypt_state.rounds = 16;
+      break;
+#endif
+/* rain - added AES support */
+#ifdef HAVE_EVP_AES_128_CFB
+    case CIPHER_AES_128:
+      out_state.crypt_state.cipher = EVP_aes_128_cfb();
+      break;
+#endif
+#ifdef HAVE_EVP_AES_192_CFB
+    case CIPHER_AES_192:
+      out_state.crypt_state.cipher = EVP_aes_192_cfb();
+      break;
+#endif
+#ifdef HAVE_EVP_AES_256_CFB
+    case CIPHER_AES_256:
+      out_state.crypt_state.cipher = EVP_aes_256_cfb();
       break;
 #endif
     default:
diff -uNrd ircd-hybrid-7.0/servlink/servlink.c anynet-3.0/servlink/servlink.c
--- ircd-hybrid-7.0/servlink/servlink.c	Thu May 29 01:13:24 2003
+++ anynet-3.0/servlink/servlink.c	Mon Feb  2 06:41:21 2004
@@ -61,10 +61,11 @@
  */
 static void usage(void)
 {
-  fprintf(stderr, "ircd-hybrid server link v1.0\n");
+  /* rain - made ircd-hybrid references slightly more generic */
+  fprintf(stderr, "ircd server link v1.0\n");
   fprintf(stderr, "2001-06-04\n");
   fprintf(stderr, "\n");
-  fprintf(stderr, "This program is called by the ircd-hybrid ircd.\n");
+  fprintf(stderr, "This program is called by the hybrid/anynet ircd.\n");
   fprintf(stderr, "It cannot be used on its own.\n");
   exit(1);
 }
diff -uNrd ircd-hybrid-7.0/servlink/servlink.h anynet-3.0/servlink/servlink.h
--- ircd-hybrid-7.0/servlink/servlink.h	Sun Nov 24 03:27:14 2002
+++ anynet-3.0/servlink/servlink.h	Mon Feb  2 06:49:15 2004
@@ -58,6 +58,10 @@
 #define CIPHER_RC5_8    6
 #define CIPHER_RC5_12   7
 #define CIPHER_RC5_16   8
+/* rain - add AES */
+#define CIPHER_AES_128  9
+#define CIPHER_AES_192  10
+#define CIPHER_AES_256  11
 
 struct crypt_state
 {
diff -uNrd ircd-hybrid-7.0/servlink/setup.h.in anynet-3.0/servlink/setup.h.in
--- ircd-hybrid-7.0/servlink/setup.h.in	Sun Jun  3 13:39:27 2001
+++ anynet-3.0/servlink/setup.h.in	Mon Feb  2 06:48:25 2004
@@ -26,3 +26,14 @@
 
 /* Define if you have the EVP_idea_cfb function.  */
 #undef HAVE_EVP_IDEA_CFB
+
+/* rain - added AES cryptlink support */
+/* Define if you have the EVP_aes_128_cfb function. */
+#undef HAVE_EVP_AES_128_CFB
+
+/* Define if you have the EVP_aes_192_cfb function. */
+#undef HAVE_EVP_AES_192_CFB
+
+/* Define if you have the EVP_aes_256_cfb function. */
+#undef HAVE_EVP_AES_256_CFB
+
diff -uNrd ircd-hybrid-7.0/src/adns.c anynet-3.0/src/adns.c
--- ircd-hybrid-7.0/src/adns.c	Fri Apr  4 20:20:03 2003
+++ anynet-3.0/src/adns.c	Mon Feb  2 00:49:24 2004
@@ -139,9 +139,10 @@
   
   adns_forallqueries_begin(dns_state);
   
-  while((q = adns_forallqueries_next(dns_state, (void **)&r)) != NULL)
+  /* rain - corrected void ** casts to void * */
+  while((q = adns_forallqueries_next(dns_state, (void *)&r)) != NULL)
   {
-    switch(adns_check(dns_state, &q, &answer, (void **)&query))  
+    switch(adns_check(dns_state, &q, &answer, (void *)&query))  
     {
       case 0:
         /* Looks like we got a winner */            
diff -uNrd ircd-hybrid-7.0/src/channel.c anynet-3.0/src/channel.c
--- ircd-hybrid-7.0/src/channel.c	Thu May 29 00:02:36 2003
+++ anynet-3.0/src/channel.c	Mon Feb  2 01:24:30 2004
@@ -1128,7 +1128,7 @@
 
   if (chptr->mode.limit && chptr->users >= chptr->mode.limit)
     return (ERR_CHANNELISFULL);
-
+  
   return 0;
 }
 
@@ -1242,6 +1242,10 @@
 int
 can_send(struct Channel *chptr, struct Client *source_p)
 {
+  /* rain - services can always send to channels */
+  if (IsService(source_p))
+    return (CAN_SEND_OPV);
+
   if(MyClient(source_p) &&
      (find_channel_resv(chptr->chname) &&
       !(IsOper(source_p)) && ConfigChannel.oper_pass_resv))
diff -uNrd ircd-hybrid-7.0/src/channel_mode.c anynet-3.0/src/channel_mode.c
--- ircd-hybrid-7.0/src/channel_mode.c	Sat Apr 19 22:33:41 2003
+++ anynet-3.0/src/channel_mode.c	Mon Feb  2 02:29:32 2004
@@ -499,10 +499,11 @@
   if (chptr->mode.mode & MODE_HIDEOPS)
     *mbuf++ = 'a';
 #endif
+
   if (chptr->mode.limit)
   {
     *mbuf++ = 'l';
-    if (IsMember(client_p, chptr) || IsServer(client_p))
+    if (IsMember(client_p, chptr) || IsServer(client_p) || IsOper(client_p))
     {
       len = ircsprintf(pbuf, "%d ", chptr->mode.limit);
       pbuf += len;
@@ -511,7 +512,7 @@
   if (*chptr->mode.key)
   {
     *mbuf++ = 'k';
-    if (IsMember(client_p, chptr) || IsServer(client_p))
+    if (IsMember(client_p, chptr) || IsServer(client_p) || IsAdmin(client_p))
       ircsprintf(pbuf, "%s ", chptr->mode.key);
   }
 
@@ -814,8 +815,11 @@
   /* dont allow halfops to set +-p, as this controls whether they can set
    * +-h or not.. all other simple modes are ok
    */
-  if((alev < CHACCESS_HALFOP) ||
-    ((mode_type == MODE_PRIVATE) && (alev < CHACCESS_CHANOP)))
+
+  /* rain - services support */
+  if(((alev < CHACCESS_HALFOP) ||
+    ((mode_type == MODE_PRIVATE) && (alev < CHACCESS_CHANOP))) &&
+    !IsService(source_p))
   {
     if (!(*errors & SM_ERR_NOOPS))
       sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
@@ -824,6 +828,7 @@
     return;
   }
 
+
   /* If have already dealt with this simple mode, ignore it */
   if (simple_modes_mask & mode_type)
     return;
@@ -872,7 +877,8 @@
   if(!ConfigChannel.use_anonops)
     return;
 
-  if (alev < CHACCESS_HALFOP)
+  /* rain - services support */
+  if (alev < CHACCESS_HALFOP && !IsService(source_p))
   {
     if (!(*errors & SM_ERR_NOOPS))
       sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
@@ -933,7 +939,7 @@
     *errors |= SM_ERR_RPL_B;
 
 #ifdef ANONOPS
-    if ((chptr->mode.mode & MODE_HIDEOPS) && (alev < CHACCESS_HALFOP))
+    if ((chptr->mode.mode & MODE_HIDEOPS) && (alev < CHACCESS_HALFOP) && !IsOper(client_p))
       DLINK_FOREACH(ptr, chptr->banlist.head)
       {
         banptr = ptr->data;
@@ -955,7 +961,8 @@
     return;
   }
 
-  if (alev < CHACCESS_HALFOP)
+  /* rain - services support */
+  if (alev < CHACCESS_HALFOP && !IsService(client_p))
   {
     if (!(*errors & SM_ERR_NOOPS))
       sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
@@ -1048,7 +1055,8 @@
     return;
   }
 
-  if (alev < CHACCESS_HALFOP)
+  /* rain - services support */
+  if (alev < CHACCESS_HALFOP && !IsService(source_p))
   {
     if (!(*errors & SM_ERR_NOOPS))
       sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
@@ -1150,7 +1158,8 @@
     return;
   }
 
-  if (alev < CHACCESS_HALFOP)
+  /* rain - services support */
+  if (alev < CHACCESS_HALFOP && !IsService(source_p))
   {
     if (!(*errors & SM_ERR_NOOPS))
       sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
@@ -1258,7 +1267,8 @@
   int wasnt_hopped = 0;
 #endif
 
-  if (alev < CHACCESS_CHANOP)
+  /* rain - services support */
+  if (alev < CHACCESS_CHANOP && !IsService(source_p))
   {
     if (!(*errors & SM_ERR_NOOPS))
       sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
@@ -1463,9 +1473,10 @@
  * +p is set(although they can set +p) so it is safe to use this to
  * control whether they can (de)halfop...
  */
-  if (alev <
+  /* rain - services support */
+  if ((alev <
       ((chptr->mode.mode & MODE_PRIVATE) ?
-        CHACCESS_CHANOP : CHACCESS_HALFOP))
+        CHACCESS_CHANOP : CHACCESS_HALFOP)) && !IsService(source_p))
   {
     if (!(*errors & SM_ERR_NOOPS))
       sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
@@ -1607,7 +1618,8 @@
   char *opnick;
   struct Client *targ_p;
 
-  if (alev < CHACCESS_HALFOP)
+  /* rain - services support */
+  if (alev < CHACCESS_HALFOP && !IsService(source_p))
   {
     if (!(*errors & SM_ERR_NOOPS))
       sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
@@ -1694,7 +1706,8 @@
   int i, limit;
   char *lstr;
 
-  if (alev < CHACCESS_HALFOP)
+  /* rain - services support */
+  if (alev < CHACCESS_HALFOP && !IsService(source_p))
   {
     if (!(*errors & SM_ERR_NOOPS))
       sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
@@ -1758,7 +1771,8 @@
   int i;
   char *key;
 
-  if (alev < CHACCESS_HALFOP)
+  /* rain - services support */
+  if (alev < CHACCESS_HALFOP && !IsService(source_p))
   {
     if (!(*errors & SM_ERR_NOOPS))
       sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
@@ -2094,8 +2108,10 @@
   st = ALL_MEMBERS;
 #endif
 
+  /* rain - show source server if hide_servers is off */
   if (IsServer(source_p))
-    mbl = ircsprintf(modebuf, ":%s MODE %s ", me.name, chname);
+    mbl = ircsprintf(modebuf, ":%s MODE %s ", ConfigServerHide.hide_servers ?
+                     me.name : source_p->name, chname);
   else
     mbl = ircsprintf(modebuf, ":%s!%s@%s MODE %s ", source_p->name,
                      source_p->username, source_p->host, chname);
@@ -2133,8 +2149,10 @@
       nc = 0;
       mc = 0;
 
+      /* rain - show source server if hide_servers is off */
       if (IsServer(source_p))
-        mbl = ircsprintf(modebuf, ":%s MODE %s ", me.name, chname);
+        mbl = ircsprintf(modebuf, ":%s MODE %s ",
+          ConfigServerHide.hide_servers ? me.name : source_p->name, chname);
       else
         mbl = ircsprintf(modebuf, ":%s!%s@%s MODE %s ", source_p->name,
                    source_p->username, source_p->host, chname);
